
//=======================================================
//  This code is generated by Terasic System Builder
//=======================================================

module DE0_Nano(

	//////////// CLOCK //////////
	CLOCK_50,

	//////////// LED //////////
	LED,

	//////////// KEY //////////
	KEY,

	//////////// SW //////////
	SW,

	//////////// SDRAM //////////
	DRAM_ADDR,
	DRAM_BA,
	DRAM_CAS_N,
	DRAM_CKE,
	DRAM_CLK,
	DRAM_CS_N,
	DRAM_DQ,
	DRAM_DQM,
	DRAM_RAS_N,
	DRAM_WE_N,

	//////////// EPCS //////////
	EPCS_ASDO,
	EPCS_DATA0,
	EPCS_DCLK,
	EPCS_NCSO,

	//////////// Accelerometer and EEPROM //////////
	G_SENSOR_CS_N,
	G_SENSOR_INT,
	I2C_SCLK,
	I2C_SDAT, 
 
	//////////// ADC //////////
	ADC_CS_N,
	ADC_SADDR,
	ADC_SCLK,
	ADC_SDAT,

	//////////// 2x13 GPIO Header //////////
	GPIO_2,
	GPIO_2_IN,

	//////////// GPIO_0, GPIO_0 connect to GPIO Default //////////
	GPIO_0,
	GPIO_0_IN,

	//////////// GPIO_1, GPIO_1 connect to GPIO Default //////////
	GPIO_1,
	GPIO_1_IN 
);

//=======================================================
//  PARAMETER declarations
//=======================================================


//=======================================================
//  PORT declarations
//=======================================================

//////////// CLOCK //////////
input 		          		CLOCK_50;

//////////// LED //////////
output		     [7:0]		LED;

//////////// KEY //////////
input 		     [1:0]		KEY;

//////////// SW //////////
input 		     [3:0]		SW;

//////////// SDRAM //////////
output		    [12:0]		DRAM_ADDR;
output		     [1:0]		DRAM_BA;
output		          		DRAM_CAS_N;
output		          		DRAM_CKE;
output		          		DRAM_CLK;
output		          		DRAM_CS_N;
inout 		    [15:0]		DRAM_DQ;
output		     [1:0]		DRAM_DQM;
output		          		DRAM_RAS_N;
output		          		DRAM_WE_N;

//////////// EPCS //////////
output		          		EPCS_ASDO;
input 		          		EPCS_DATA0;
output		          		EPCS_DCLK;
output		          		EPCS_NCSO;

//////////// Accelerometer and EEPROM //////////
output		          		G_SENSOR_CS_N;
input 		          		G_SENSOR_INT;
output		          		I2C_SCLK;
inout 		          		I2C_SDAT;

//////////// ADC //////////
output		          		ADC_CS_N;
output		          		ADC_SADDR;
output		          		ADC_SCLK;
input 		          		ADC_SDAT;

//////////// 2x13 GPIO Header //////////
inout 		    [12:0]		GPIO_2;
input 		     [2:0]		GPIO_2_IN;

//////////// GPIO_0, GPIO_0 connect to GPIO Default //////////
inout 		    [33:0]		GPIO_0;
input 		     [1:0]		GPIO_0_IN;

//////////// GPIO_1, GPIO_1 connect to GPIO Default //////////
inout 		    [33:0]		GPIO_1;
input 		     [1:0]		GPIO_1_IN;


//=======================================================
//  REG/WIRE declarations
//=======================================================


//
//wire SPI_RESET;
//wire SPI_START;
//wire SPI_FINISH;
//wire SPI_WR;
//wire SPI_READY;
//wire [15:0]SPI_ADDRESS;
//wire [7:0]NIOS_TO_WIZNET;
//wire [7:0]SPI_TO_NIOS;
//wire [23:0]DATA_IN_SPI={SPI_ADDRESS[15:0],NIOS_TO_WIZNET[7:0]};
//wire [7:0]NIOS_LEDS;
//assign GPIO_0[7]=SPI_RESET;
//
//assign LED_PORT=8'd0;
//
////=======================================================
////  Structural coding
////=======================================================
//
//SPI_MASTER SPI_MASTER_inst
//(
//	.WRITE_READ(SPI_WR) ,	// input  WRITE_READ_sig
//	.DATA_IN(DATA_IN_SPI[23:0]) ,	// input [23:0] DATA_IN_sig
//	.DATA_OUT(SPI_TO_NIOS[7:0]) ,	// output [7:0] DATA_OUT_sig
//	.CLK_SPI(CLOCK_50) ,	// input  CLK_SPI_sig
//	
//	.SS_n(GPIO_0[0]) ,	// output  SS_n_sig
//	.SLCK(GPIO_0[1]) ,	// output  SLCK_sig
//	.MOSI(GPIO_0[3]) ,	// output  MOSI_sig
//	.MISO(GPIO_0[5]), 	// input  MISO_sig
//	
//	.RDY(SPI_READY) ,	// output  RDY_sig
//	.START(SPI_START) ,	// input  START_sig
//	.SPI_IDLE(SPI_FINISH) 	// output  SPI_IDLE_sig
//	
//);		
//
//


 DE0_NANO_QSYS u0(
		.clk_clk(CLOCK_50),                         //                      clk.clk
		.reset_reset_n(1'b1),                   //                    reset.reset_n
		.altpll_sdram_clk(DRAM_CLK),                //             altpll_sdram.clk
		.altpll_areset_conduit_export(1'b0),    //    altpll_areset_conduit.export
		.key_external_connection_export(KEY),  //  key_external_connection.export
		
		.sdram_wire_addr(DRAM_ADDR),                 //               sdram_wire.addr
		.sdram_wire_ba(DRAM_BA),                   //                         .ba
		.sdram_wire_cas_n(DRAM_CAS_N),                //                         .cas_n
		.sdram_wire_cke(DRAM_CKE),                  //                         .cke
		.sdram_wire_cs_n(DRAM_CS_N),                 //                         .cs_n
		.sdram_wire_dq(DRAM_DQ),                   //                         .dq
		.sdram_wire_dqm(DRAM_DQM),                  //                         .dqm
		.sdram_wire_ras_n(DRAM_RAS_N),                //                         .ras_n
		.sdram_wire_we_n(DRAM_WE_N),                 //                         .we_n
	  
	 
	  .ethernet_wiznet_5100_wiznet_ss_n           (GPIO_0[0]),           //                ethernet_wiznet_5100.wiznet_ss_n
	  .ethernet_wiznet_5100_wiznet_sclk           (GPIO_0[1]),           //                                    .wiznet_sclk
	  .ethernet_wiznet_5100_wiznet_mosi           (GPIO_0[3]),           //                                    .wiznet_mosi
	  .ethernet_wiznet_5100_wiznet_miso           (GPIO_0[5]),           //                                    .wiznet_miso
	  .ethernet_wiznet_5100_wiznet_reset          (GPIO_0[7])           //                                    .wiznet_reset
	 
	);

endmodule
