// --------------------------------------------------------------------
// Copyright (c) 2017 by FPGALOVER
// --------------------------------------------------------------------
//                     web: http://www.fpgalover.com
//                     email: admin@fpgalover.com or hbecerra@ece.ubc.ca
// --------------------------------------------------------------------
//	Author: Holguer Andres Becerra Daza
//  Description: SW example
// --------------------------------------------------------------------
// **************************************************************************/

#include <stdio.h>
#include "includes.h"

#include "wiznet/W5100_configs.h"

/* Definition of Task Stacks */
#define   TASK_STACKSIZE       2048
OS_STK task1_stk[TASK_STACKSIZE];
OS_STK task2_stk[TASK_STACKSIZE];

/* Definition of Task Priorities */

#define TASK1_PRIORITY      1
#define TASK2_PRIORITY      2

void tcp_client(void* pdata);
void http_server(void* pdata);
void init_hw();

void init_hw() {
	if (!reset_wiznet()) {
		printf("-- Wiznet-Ethernet Fail(SPI)\n");
	} else {
		printf("-- Wiznet-Ethernet SPI Succeeded\n");
	}
}

//HTTP Server example
void http_server(void* pdata) {
	init_hw();

	if (init_dhcpc_ch(_DHCP_SOCKET) == 0) {
		printf("IP STATIC or DHCP not Working, check Flags...\n");
	}else{

	}

	OSTaskCreateExt(tcp_client,
	NULL, (void *) &task2_stk[TASK_STACKSIZE - 1],
	TASK2_PRIORITY,
	TASK2_PRIORITY, task2_stk,
	TASK_STACKSIZE,
	NULL, 0);

	HTTP_Init(HTTP_SOCKET, HTTP_PORT);
	while (1) {
		HTTP_Server_example();
		OSTimeDlyHMSM(0, 0, 0, 100);
	}
}
//TCP Client example
void tcp_client(void* pdata) {
	unsigned char tcp_server_address[4];
	tcp_server_address[0] = 192;
	tcp_server_address[1] = 168;
	tcp_server_address[2] = 1;
	tcp_server_address[3] = 71;

	TCP_client_init(_TCP_SOCKET, tcp_server_address, 787);
	while (1) {
		TcP_Client();
		OSTimeDlyHMSM(0, 0, 0, 400);
	}
}

void UDP_streaming(void* pdata) {
	while (1) {

		OSTimeDlyHMSM(0, 0, 0, 500);
	}
}

/* The main function creates two task and starts multi-tasking */
int main(void) {

	OSTaskCreateExt(http_server,
	NULL, (void *) &task1_stk[TASK_STACKSIZE - 1],
	TASK1_PRIORITY,
	TASK1_PRIORITY, task1_stk,
	TASK_STACKSIZE,
	NULL, 0);

	OSStart();
}

/******************************************************************************
 *                                                                             *
 * License Agreement                                                           *
 *                                                                             *
 * Copyright (c) 2004 Altera Corporation, San Jose, California, USA.           *
 * All rights reserved.                                                        *
 *                                                                             *
 * Permission is hereby granted, free of charge, to any person obtaining a     *
 * copy of this software and associated documentation files (the "Software"),  *
 * to deal in the Software without restriction, including without limitation   *
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,    *
 * and/or sell copies of the Software, and to permit persons to whom the       *
 * Software is furnished to do so, subject to the following conditions:        *
 *                                                                             *
 * The above copyright notice and this permission notice shall be included in  *
 * all copies or substantial portions of the Software.                         *
 *                                                                             *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR  *
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,    *
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE *
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER      *
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING     *
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER         *
 * DEALINGS IN THE SOFTWARE.                                                   *
 *                                                                             *
 * This agreement shall be governed in all respects by the laws of the State   *
 * of California and by the laws of the United States of America.              *
 * Altera does not recommend, suggest or require that this reference design    *
 * file be used in conjunction or combination with any other product.          *
 ******************************************************************************/
